/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Contents of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.418 - (show annotations) (download)
Wed May 15 19:01:36 2013 UTC (14 months ago) by mgorny
Branch: MAIN
Changes since 1.417: +64 -55 lines
prune_libtool_files: do not remove .la files which are not libtool files. Fixes bug #468380.

1 # Copyright 1999-2013 Gentoo Foundation
2 # Distributed under the terms of the GNU General Public License v2
3 # $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.417 2013/04/25 18:38:02 vapier Exp $
4
5 # @ECLASS: eutils.eclass
6 # @MAINTAINER:
7 # base-system@gentoo.org
8 # @BLURB: many extra (but common) functions that are used in ebuilds
9 # @DESCRIPTION:
10 # The eutils eclass contains a suite of functions that complement
11 # the ones that ebuild.sh already contain. The idea is that the functions
12 # are not required in all ebuilds but enough utilize them to have a common
13 # home rather than having multiple ebuilds implementing the same thing.
14 #
15 # Due to the nature of this eclass, some functions may have maintainers
16 # different from the overall eclass!
17
18 if [[ ${___ECLASS_ONCE_EUTILS} != "recur -_+^+_- spank" ]] ; then
19 ___ECLASS_ONCE_EUTILS="recur -_+^+_- spank"
20
21 inherit multilib toolchain-funcs user
22
23 if has "${EAPI:-0}" 0 1 2; then
24
25 # @FUNCTION: epause
26 # @USAGE: [seconds]
27 # @DESCRIPTION:
28 # Sleep for the specified number of seconds (default of 5 seconds). Useful when
29 # printing a message the user should probably be reading and often used in
30 # conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
31 # don't wait at all. Defined in EAPIs 0 1 and 2.
32 epause() {
33 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
34 }
35
36 # @FUNCTION: ebeep
37 # @USAGE: [number of beeps]
38 # @DESCRIPTION:
39 # Issue the specified number of beeps (default of 5 beeps). Useful when
40 # printing a message the user should probably be reading and often used in
41 # conjunction with the epause function. If the EBEEP_IGNORE env var is set,
42 # don't beep at all. Defined in EAPIs 0 1 and 2.
43 ebeep() {
44 local n
45 if [[ -z ${EBEEP_IGNORE} ]] ; then
46 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
47 echo -ne "\a"
48 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null
49 echo -ne "\a"
50 sleep 1
51 done
52 fi
53 }
54
55 else
56
57 ebeep() {
58 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
59 }
60
61 epause() {
62 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
63 }
64
65 fi
66
67 # @FUNCTION: eqawarn
68 # @USAGE: [message]
69 # @DESCRIPTION:
70 # Proxy to ewarn for package managers that don't provide eqawarn and use the PM
71 # implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
72 # profile.
73 if ! declare -F eqawarn >/dev/null ; then
74 eqawarn() {
75 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
76 :
77 }
78 fi
79
80 # @FUNCTION: ecvs_clean
81 # @USAGE: [list of dirs]
82 # @DESCRIPTION:
83 # Remove CVS directories recursiveley. Useful when a source tarball contains
84 # internal CVS directories. Defaults to $PWD.
85 ecvs_clean() {
86 [[ -z $* ]] && set -- .
87 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
88 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
89 }
90
91 # @FUNCTION: esvn_clean
92 # @USAGE: [list of dirs]
93 # @DESCRIPTION:
94 # Remove .svn directories recursiveley. Useful when a source tarball contains
95 # internal Subversion directories. Defaults to $PWD.
96 esvn_clean() {
97 [[ -z $* ]] && set -- .
98 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
99 }
100
101 # @FUNCTION: estack_push
102 # @USAGE: <stack> [items to push]
103 # @DESCRIPTION:
104 # Push any number of items onto the specified stack. Pick a name that
105 # is a valid variable (i.e. stick to alphanumerics), and push as many
106 # items as you like onto the stack at once.
107 #
108 # The following code snippet will echo 5, then 4, then 3, then ...
109 # @CODE
110 # estack_push mystack 1 2 3 4 5
111 # while estack_pop mystack i ; do
112 # echo "${i}"
113 # done
114 # @CODE
115 estack_push() {
116 [[ $# -eq 0 ]] && die "estack_push: incorrect # of arguments"
117 local stack_name="__ESTACK_$1__" ; shift
118 eval ${stack_name}+=\( \"\$@\" \)
119 }
120
121 # @FUNCTION: estack_pop
122 # @USAGE: <stack> [variable]
123 # @DESCRIPTION:
124 # Pop a single item off the specified stack. If a variable is specified,
125 # the popped item is stored there. If no more items are available, return
126 # 1, else return 0. See estack_push for more info.
127 estack_pop() {
128 [[ $# -eq 0 || $# -gt 2 ]] && die "estack_pop: incorrect # of arguments"
129
130 # We use the fugly __estack_xxx var names to avoid collision with
131 # passing back the return value. If we used "local i" and the
132 # caller ran `estack_pop ... i`, we'd end up setting the local
133 # copy of "i" rather than the caller's copy. The __estack_xxx
134 # garbage is preferable to using $1/$2 everywhere as that is a
135 # bit harder to read.
136 local __estack_name="__ESTACK_$1__" ; shift
137 local __estack_retvar=$1 ; shift
138 eval local __estack_i=\${#${__estack_name}\[@\]}
139 # Don't warn -- let the caller interpret this as a failure
140 # or as normal behavior (akin to `shift`)
141 [[ $(( --__estack_i )) -eq -1 ]] && return 1
142
143 if [[ -n ${__estack_retvar} ]] ; then
144 eval ${__estack_retvar}=\"\${${__estack_name}\[${__estack_i}\]}\"
145 fi
146 eval unset ${__estack_name}\[${__estack_i}\]
147 }
148
149 # @FUNCTION: eshopts_push
150 # @USAGE: [options to `set` or `shopt`]
151 # @DESCRIPTION:
152 # Often times code will want to enable a shell option to change code behavior.
153 # Since changing shell options can easily break other pieces of code (which
154 # assume the default state), eshopts_push is used to (1) push the current shell
155 # options onto a stack and (2) pass the specified arguments to set.
156 #
157 # If the first argument is '-s' or '-u', we assume you want to call `shopt`
158 # rather than `set` as there are some options only available via that.
159 #
160 # A common example is to disable shell globbing so that special meaning/care
161 # may be used with variables/arguments to custom functions. That would be:
162 # @CODE
163 # eshopts_push -s noglob
164 # for x in ${foo} ; do
165 # if ...some check... ; then
166 # eshopts_pop
167 # return 0
168 # fi
169 # done
170 # eshopts_pop
171 # @CODE
172 eshopts_push() {
173 if [[ $1 == -[su] ]] ; then
174 estack_push eshopts "$(shopt -p)"
175 [[ $# -eq 0 ]] && return 0
176 shopt "$@" || die "${FUNCNAME}: bad options to shopt: $*"
177 else
178 estack_push eshopts $-
179 [[ $# -eq 0 ]] && return 0
180 set "$@" || die "${FUNCNAME}: bad options to set: $*"
181 fi
182 }
183
184 # @FUNCTION: eshopts_pop
185 # @USAGE:
186 # @DESCRIPTION:
187 # Restore the shell options to the state saved with the corresponding
188 # eshopts_push call. See that function for more details.
189 eshopts_pop() {
190 local s
191 estack_pop eshopts s || die "${FUNCNAME}: unbalanced push"
192 if [[ ${s} == "shopt -"* ]] ; then
193 eval "${s}" || die "${FUNCNAME}: sanity: invalid shopt options: ${s}"
194 else
195 set +$- || die "${FUNCNAME}: sanity: invalid shell settings: $-"
196 set -${s} || die "${FUNCNAME}: sanity: unable to restore saved shell settings: ${s}"
197 fi
198 }
199
200 # @FUNCTION: eumask_push
201 # @USAGE: <new umask>
202 # @DESCRIPTION:
203 # Set the umask to the new value specified while saving the previous
204 # value onto a stack. Useful for temporarily changing the umask.
205 eumask_push() {
206 estack_push eumask "$(umask)"
207 umask "$@" || die "${FUNCNAME}: bad options to umask: $*"
208 }
209
210 # @FUNCTION: eumask_pop
211 # @USAGE:
212 # @DESCRIPTION:
213 # Restore the previous umask state.
214 eumask_pop() {
215 [[ $# -eq 0 ]] || die "${FUNCNAME}: we take no options"
216 local s
217 estack_pop eumask s || die "${FUNCNAME}: unbalanced push"
218 umask ${s} || die "${FUNCNAME}: sanity: could not restore umask: ${s}"
219 }
220
221 # @VARIABLE: EPATCH_SOURCE
222 # @DESCRIPTION:
223 # Default directory to search for patches.
224 EPATCH_SOURCE="${WORKDIR}/patch"
225 # @VARIABLE: EPATCH_SUFFIX
226 # @DESCRIPTION:
227 # Default extension for patches (do not prefix the period yourself).
228 EPATCH_SUFFIX="patch.bz2"
229 # @VARIABLE: EPATCH_OPTS
230 # @DESCRIPTION:
231 # Options to pass to patch. Meant for ebuild/package-specific tweaking
232 # such as forcing the patch level (-p#) or fuzz (-F#) factor. Note that
233 # for single patch tweaking, you can also pass flags directly to epatch.
234 EPATCH_OPTS=""
235 # @VARIABLE: EPATCH_COMMON_OPTS
236 # @DESCRIPTION:
237 # Common options to pass to `patch`. You probably should never need to
238 # change these. If you do, please discuss it with base-system first to
239 # be sure.
240 # @CODE
241 # -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
242 # --no-backup-if-mismatch - do not leave .orig files behind
243 # -E - automatically remove empty files
244 # @CODE
245 EPATCH_COMMON_OPTS="-g0 -E --no-backup-if-mismatch"
246 # @VARIABLE: EPATCH_EXCLUDE
247 # @DESCRIPTION:
248 # List of patches not to apply. Note this is only file names,
249 # and not the full path. Globs accepted.
250 EPATCH_EXCLUDE=""
251 # @VARIABLE: EPATCH_SINGLE_MSG
252 # @DESCRIPTION:
253 # Change the printed message for a single patch.
254 EPATCH_SINGLE_MSG=""
255 # @VARIABLE: EPATCH_MULTI_MSG
256 # @DESCRIPTION:
257 # Change the printed message for multiple patches.
258 EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
259 # @VARIABLE: EPATCH_FORCE
260 # @DESCRIPTION:
261 # Only require patches to match EPATCH_SUFFIX rather than the extended
262 # arch naming style.
263 EPATCH_FORCE="no"
264 # @VARIABLE: EPATCH_USER_EXCLUDE
265 # @DEFAULT_UNSET
266 # @DESCRIPTION:
267 # List of patches not to apply. Note this is only file names,
268 # and not the full path. Globs accepted.
269
270 # @FUNCTION: epatch
271 # @USAGE: [options] [patches] [dirs of patches]
272 # @DESCRIPTION:
273 # epatch is designed to greatly simplify the application of patches. It can
274 # process patch files directly, or directories of patches. The patches may be
275 # compressed (bzip/gzip/etc...) or plain text. You generally need not specify
276 # the -p option as epatch will automatically attempt -p0 to -p5 until things
277 # apply successfully.
278 #
279 # If you do not specify any patches/dirs, then epatch will default to the
280 # directory specified by EPATCH_SOURCE.
281 #
282 # Any options specified that start with a dash will be passed down to patch
283 # for this specific invocation. As soon as an arg w/out a dash is found, then
284 # arg processing stops.
285 #
286 # When processing directories, epatch will apply all patches that match:
287 # @CODE
288 # if ${EPATCH_FORCE} != "yes"
289 # ??_${ARCH}_foo.${EPATCH_SUFFIX}
290 # else
291 # *.${EPATCH_SUFFIX}
292 # @CODE
293 # The leading ?? are typically numbers used to force consistent patch ordering.
294 # The arch field is used to apply patches only for the host architecture with
295 # the special value of "all" means apply for everyone. Note that using values
296 # other than "all" is highly discouraged -- you should apply patches all the
297 # time and let architecture details be detected at configure/compile time.
298 #
299 # If EPATCH_SUFFIX is empty, then no period before it is implied when searching
300 # for patches to apply.
301 #
302 # Refer to the other EPATCH_xxx variables for more customization of behavior.
303 epatch() {
304 _epatch_draw_line() {
305 # create a line of same length as input string
306 [[ -z $1 ]] && set "$(printf "%65s" '')"
307 echo "${1//?/=}"
308 }
309
310 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
311
312 # First process options. We localize the EPATCH_OPTS setting
313 # from above so that we can pass it on in the loop below with
314 # any additional values the user has specified.
315 local EPATCH_OPTS=( ${EPATCH_OPTS[*]} )
316 while [[ $# -gt 0 ]] ; do
317 case $1 in
318 -*) EPATCH_OPTS+=( "$1" ) ;;
319 *) break ;;
320 esac
321 shift
322 done
323
324 # Let the rest of the code process one user arg at a time --
325 # each arg may expand into multiple patches, and each arg may
326 # need to start off with the default global EPATCH_xxx values
327 if [[ $# -gt 1 ]] ; then
328 local m
329 for m in "$@" ; do
330 epatch "${m}"
331 done
332 return 0
333 fi
334
335 local SINGLE_PATCH="no"
336 # no args means process ${EPATCH_SOURCE}
337 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
338
339 if [[ -f $1 ]] ; then
340 SINGLE_PATCH="yes"
341 set -- "$1"
342 # Use the suffix from the single patch (localize it); the code
343 # below will find the suffix for us
344 local EPATCH_SUFFIX=$1
345
346 elif [[ -d $1 ]] ; then
347 # Some people like to make dirs of patches w/out suffixes (vim)
348 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
349
350 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
351 # Re-use EPATCH_SOURCE as a search dir
352 epatch "${EPATCH_SOURCE}/$1"
353 return $?
354
355 else
356 # sanity check ... if it isn't a dir or file, wtf man ?
357 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
358 echo
359 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
360 eerror
361 eerror " ${EPATCH_SOURCE}"
362 eerror " ( ${EPATCH_SOURCE##*/} )"
363 echo
364 die "Cannot find \$EPATCH_SOURCE!"
365 fi
366
367 # Now that we know we're actually going to apply something, merge
368 # all of the patch options back in to a single variable for below.
369 EPATCH_OPTS="${EPATCH_COMMON_OPTS} ${EPATCH_OPTS[*]}"
370
371 local PIPE_CMD
372 case ${EPATCH_SUFFIX##*\.} in
373 xz) PIPE_CMD="xz -dc" ;;
374 lzma) PIPE_CMD="lzma -dc" ;;
375 bz2) PIPE_CMD="bzip2 -dc" ;;
376 gz|Z|z) PIPE_CMD="gzip -dc" ;;
377 ZIP|zip) PIPE_CMD="unzip -p" ;;
378 *) ;;
379 esac
380
381 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
382
383 local x
384 for x in "$@" ; do
385 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
386 # didn't match anything, ignore continue on
387 [[ ! -f ${x} ]] && continue
388
389 local patchname=${x##*/}
390
391 # Apply single patches, or forced sets of patches, or
392 # patches with ARCH dependant names.
393 # ???_arch_foo.patch
394 # Else, skip this input altogether
395 local a=${patchname#*_} # strip the ???_
396 a=${a%%_*} # strip the _foo.patch
397 if ! [[ ${SINGLE_PATCH} == "yes" || \
398 ${EPATCH_FORCE} == "yes" || \
399 ${a} == all || \
400 ${a} == ${ARCH} ]]
401 then
402 continue
403 fi
404
405 # Let people filter things dynamically
406 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
407 # let people use globs in the exclude
408 eshopts_push -o noglob
409
410 local ex
411 for ex in ${EPATCH_EXCLUDE} ; do
412 if [[ ${patchname} == ${ex} ]] ; then
413 einfo " Skipping ${patchname} due to EPATCH_EXCLUDE ..."
414 eshopts_pop
415 continue 2
416 fi
417 done
418
419 for ex in ${EPATCH_USER_EXCLUDE} ; do
420 if [[ ${patchname} == ${ex} ]] ; then
421 einfo " Skipping ${patchname} due to EPATCH_USER_EXCLUDE ..."
422 eshopts_pop
423 continue 2
424 fi
425 done
426
427 eshopts_pop
428 fi
429
430 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
431 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
432 einfo "${EPATCH_SINGLE_MSG}"
433 else
434 einfo "Applying ${patchname} ..."
435 fi
436 else
437 einfo " ${patchname} ..."
438 fi
439
440 # most of the time, there will only be one run per unique name,
441 # but if there are more, make sure we get unique log filenames
442 local STDERR_TARGET="${T}/${patchname}.out"
443 if [[ -e ${STDERR_TARGET} ]] ; then
444 STDERR_TARGET="${T}/${patchname}-$$.out"
445 fi
446
447 printf "***** %s *****\nPWD: %s\n\n" "${patchname}" "${PWD}" > "${STDERR_TARGET}"
448
449 # Decompress the patch if need be
450 local count=0
451 local PATCH_TARGET
452 if [[ -n ${PIPE_CMD} ]] ; then
453 PATCH_TARGET="${T}/$$.patch"
454 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
455
456 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
457 echo
458 eerror "Could not extract patch!"
459 #die "Could not extract patch!"
460 count=5
461 break
462 fi
463 else
464 PATCH_TARGET=${x}
465 fi
466
467 # Check for absolute paths in patches. If sandbox is disabled,
468 # people could (accidently) patch files in the root filesystem.
469 # Or trigger other unpleasantries #237667. So disallow -p0 on
470 # such patches.
471 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
472 if [[ -n ${abs_paths} ]] ; then
473 count=1
474 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
475 fi
476 # Similar reason, but with relative paths.
477 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
478 if [[ -n ${rel_paths} ]] ; then
479 eqawarn "QA Notice: Your patch uses relative paths '../'."
480 eqawarn " In the future this will cause a failure."
481 eqawarn "${rel_paths}"
482 fi
483
484 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
485 local patch_cmd
486 # Handle aliased patch command #404447 #461568
487 local patch="patch"
488 eval $(alias patch 2>/dev/null | sed 's:^alias ::')
489 while [[ ${count} -lt 5 ]] ; do
490 patch_cmd="${patch} -p${count} ${EPATCH_OPTS}"
491
492 # Generate some useful debug info ...
493 (
494 _epatch_draw_line "***** ${patchname} *****"
495 echo
496 echo "PATCH COMMAND: ${patch_cmd} < '${PATCH_TARGET}'"
497 echo
498 _epatch_draw_line "***** ${patchname} *****"
499 ${patch_cmd} --dry-run -f < "${PATCH_TARGET}" 2>&1
500 ret=$?
501 echo
502 echo "patch program exited with status ${ret}"
503 exit ${ret}
504 ) >> "${STDERR_TARGET}"
505
506 if [ $? -eq 0 ] ; then
507 (
508 _epatch_draw_line "***** ${patchname} *****"
509 echo
510 echo "ACTUALLY APPLYING ${patchname} ..."
511 echo
512 _epatch_draw_line "***** ${patchname} *****"
513 ${patch_cmd} < "${PATCH_TARGET}" 2>&1
514 ret=$?
515 echo
516 echo "patch program exited with status ${ret}"
517 exit ${ret}
518 ) >> "${STDERR_TARGET}"
519
520 if [ $? -ne 0 ] ; then
521 echo
522 eerror "A dry-run of patch command succeeded, but actually"
523 eerror "applying the patch failed!"
524 #die "Real world sux compared to the dreamworld!"
525 count=5
526 fi
527 break
528 fi
529
530 : $(( count++ ))
531 done
532
533 # if we had to decompress the patch, delete the temp one
534 if [[ -n ${PIPE_CMD} ]] ; then
535 rm -f "${PATCH_TARGET}"
536 fi
537
538 if [[ ${count} -ge 5 ]] ; then
539 echo
540 eerror "Failed Patch: ${patchname} !"
541 eerror " ( ${PATCH_TARGET} )"
542 eerror
543 eerror "Include in your bugreport the contents of:"
544 eerror
545 eerror " ${STDERR_TARGET}"
546 echo
547 die "Failed Patch: ${patchname}!"
548 fi
549
550 # if everything worked, delete the full debug patch log
551 rm -f "${STDERR_TARGET}"
552
553 # then log away the exact stuff for people to review later
554 cat <<-EOF >> "${T}/epatch.log"
555 PATCH: ${x}
556 CMD: ${patch_cmd}
557 PWD: ${PWD}
558
559 EOF
560 eend 0
561 done
562
563 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
564 : # everything worked
565 }
566
567 # @FUNCTION: epatch_user
568 # @USAGE:
569 # @DESCRIPTION:
570 # Applies user-provided patches to the source tree. The patches are
571 # taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>[:SLOT]/, where the first
572 # of these three directories to exist will be the one to use, ignoring
573 # any more general directories which might exist as well. They must end
574 # in ".patch" to be applied.
575 #
576 # User patches are intended for quick testing of patches without ebuild
577 # modifications, as well as for permanent customizations a user might
578 # desire. Obviously, there can be no official support for arbitrarily
579 # patched ebuilds. So whenever a build log in a bug report mentions that
580 # user patches were applied, the user should be asked to reproduce the
581 # problem without these.
582 #
583 # Not all ebuilds do call this function, so placing patches in the
584 # stated directory might or might not work, depending on the package and
585 # the eclasses it inherits and uses. It is safe to call the function
586 # repeatedly, so it is always possible to add a call at the ebuild
587 # level. The first call is the time when the patches will be
588 # applied.
589 #
590 # Ideally, this function should be called after gentoo-specific patches
591 # have been applied, so that their code can be modified as well, but
592 # before calls to e.g. eautoreconf, as the user patches might affect
593 # autotool input files as well.
594 epatch_user() {
595 [[ $# -ne 0 ]] && die "epatch_user takes no options"
596
597 # Allow multiple calls to this function; ignore all but the first
598 local applied="${T}/epatch_user.log"
599 [[ -e ${applied} ]] && return 2
600
601 # don't clobber any EPATCH vars that the parent might want
602 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
603 for check in ${CATEGORY}/{${P}-${PR},${P},${PN}}{,:${SLOT}}; do
604 EPATCH_SOURCE=${base}/${CTARGET}/${check}
605 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
606 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
607 if [[ -d ${EPATCH_SOURCE} ]] ; then
608 EPATCH_SOURCE=${EPATCH_SOURCE} \
609 EPATCH_SUFFIX="patch" \
610 EPATCH_FORCE="yes" \
611 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
612 epatch
613 echo "${EPATCH_SOURCE}" > "${applied}"
614 return 0
615 fi
616 done
617 echo "none" > "${applied}"
618 return 1
619 }
620
621 # @FUNCTION: emktemp
622 # @USAGE: [temp dir]
623 # @DESCRIPTION:
624 # Cheap replacement for when debianutils (and thus mktemp)
625 # does not exist on the users system.
626 emktemp() {
627 local exe="touch"
628 [[ $1 == -d ]] && exe="mkdir" && shift
629 local topdir=$1
630
631 if [[ -z ${topdir} ]] ; then
632 [[ -z ${T} ]] \
633 && topdir="/tmp" \
634 || topdir=${T}
635 fi
636
637 if ! type -P mktemp > /dev/null ; then
638 # system lacks `mktemp` so we have to fake it
639 local tmp=/
640 while [[ -e ${tmp} ]] ; do
641 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
642 done
643 ${exe} "${tmp}" || ${exe} -p "${tmp}"
644 echo "${tmp}"
645 else
646 # the args here will give slightly wierd names on BSD,
647 # but should produce a usable file on all userlands
648 if [[ ${exe} == "touch" ]] ; then
649 TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
650 else
651 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
652 fi
653 fi
654 }
655
656 # @FUNCTION: edos2unix
657 # @USAGE: <file> [more files ...]
658 # @DESCRIPTION:
659 # A handy replacement for dos2unix, recode, fixdos, etc... This allows you
660 # to remove all of these text utilities from DEPEND variables because this
661 # is a script based solution. Just give it a list of files to convert and
662 # they will all be changed from the DOS CRLF format to the UNIX LF format.
663 edos2unix() {
664 [[ $# -eq 0 ]] && return 0
665 sed -i 's/\r$//' -- "$@" || die
666 }
667
668 # @FUNCTION: make_desktop_entry
669 # @USAGE: make_desktop_entry(<command>, [name], [icon], [type], [fields])
670 # @DESCRIPTION:
671 # Make a .desktop file.
672 #
673 # @CODE
674 # binary: what command does the app run with ?
675 # name: the name that will show up in the menu
676 # icon: the icon to use in the menu entry
677 # this can be relative (to /usr/share/pixmaps) or
678 # a full path to an icon
679 # type: what kind of application is this?
680 # for categories:
681 # http://standards.freedesktop.org/menu-spec/latest/apa.html
682 # if unset, function tries to guess from package's category
683 # fields: extra fields to append to the desktop file; a printf string
684 # @CODE
685 make_desktop_entry() {
686 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
687
688 local exec=${1}
689 local name=${2:-${PN}}
690 local icon=${3:-${PN}}
691 local type=${4}
692 local fields=${5}
693
694 if [[ -z ${type} ]] ; then
695 local catmaj=${CATEGORY%%-*}
696 local catmin=${CATEGORY##*-}
697 case ${catmaj} in
698 app)
699 case ${catmin} in
700 accessibility) type="Utility;Accessibility";;
701 admin) type=System;;
702 antivirus) type=System;;
703 arch) type="Utility;Archiving";;
704 backup) type="Utility;Archiving";;
705 cdr) type="AudioVideo;DiscBurning";;
706 dicts) type="Office;Dictionary";;
707 doc) type=Documentation;;
708 editors) type="Utility;TextEditor";;
709 emacs) type="Development;TextEditor";;
710 emulation) type="System;Emulator";;
711 laptop) type="Settings;HardwareSettings";;
712 office) type=Office;;
713 pda) type="Office;PDA";;
714 vim) type="Development;TextEditor";;
715 xemacs) type="Development;TextEditor";;
716 esac
717 ;;
718
719 dev)
720 type="Development"
721 ;;
722
723 games)
724 case ${catmin} in
725 action|fps) type=ActionGame;;
726 arcade) type=ArcadeGame;;
727 board) type=BoardGame;;
728 emulation) type=Emulator;;
729 kids) type=KidsGame;;
730 puzzle) type=LogicGame;;
731 roguelike) type=RolePlaying;;
732 rpg) type=RolePlaying;;
733 simulation) type=Simulation;;
734 sports) type=SportsGame;;
735 strategy) type=StrategyGame;;
736 esac
737 type="Game;${type}"
738 ;;
739
740 gnome)
741 type="Gnome;GTK"
742 ;;
743
744 kde)
745 type="KDE;Qt"
746 ;;
747
748 mail)
749 type="Network;Email"
750 ;;
751
752 media)
753 case ${catmin} in
754 gfx)
755 type=Graphics
756 ;;
757 *)
758 case ${catmin} in
759 radio) type=Tuner;;
760 sound) type=Audio;;
761 tv) type=TV;;
762 video) type=Video;;
763 esac
764 type="AudioVideo;${type}"
765 ;;
766 esac
767 ;;
768
769 net)
770 case ${catmin} in
771 dialup) type=Dialup;;
772 ftp) type=FileTransfer;;
773 im) type=InstantMessaging;;
774 irc) type=IRCClient;;
775 mail) type=Email;;
776 news) type=News;;
777 nntp) type=News;;
778 p2p) type=FileTransfer;;
779 voip) type=Telephony;;
780 esac
781 type="Network;${type}"
782 ;;
783
784 sci)
785 case ${catmin} in
786 astro*) type=Astronomy;;
787 bio*) type=Biology;;
788 calc*) type=Calculator;;
789 chem*) type=Chemistry;;
790 elec*) type=Electronics;;
791 geo*) type=Geology;;
792 math*) type=Math;;
793 physics) type=Physics;;
794 visual*) type=DataVisualization;;
795 esac
796 type="Education;Science;${type}"
797 ;;
798
799 sys)
800 type="System"
801 ;;
802
803 www)
804 case ${catmin} in
805 client) type=WebBrowser;;
806 esac
807 type="Network;${type}"
808 ;;
809
810 *)
811 type=
812 ;;
813 esac
814 fi
815 if [ "${SLOT}" == "0" ] ; then
816 local desktop_name="${PN}"
817 else
818 local desktop_name="${PN}-${SLOT}"
819 fi
820 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
821 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
822
823 # Don't append another ";" when a valid category value is provided.
824 type=${type%;}${type:+;}
825
826 eshopts_push -s extglob
827 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
828 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
829 ewarn "allowed in .desktop files if the value is not an absolute path."
830 icon=${icon%.@(xpm|png|svg)}
831 fi
832 eshopts_pop
833
834 cat <<-EOF > "${desktop}"
835 [Desktop Entry]
836 Name=${name}
837 Type=Application
838 Comment=${DESCRIPTION}
839 Exec=${exec}
840 TryExec=${exec%% *}
841 Icon=${icon}
842 Categories=${type}
843 EOF
844
845 if [[ ${fields:-=} != *=* ]] ; then
846 # 5th arg used to be value to Path=
847 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
848 fields="Path=${fields}"
849 fi
850 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
851
852 (
853 # wrap the env here so that the 'insinto' call
854 # doesn't corrupt the env of the caller
855 insinto /usr/share/applications
856 doins "${desktop}"
857 ) || die "installing desktop file failed"
858 }
859
860 # @FUNCTION: validate_desktop_entries
861 # @USAGE: [directories]
862 # @MAINTAINER:
863 # Carsten Lohrke <carlo@gentoo.org>
864 # @DESCRIPTION:
865 # Validate desktop entries using desktop-file-utils
866 validate_desktop_entries() {
867 if [[ -x /usr/bin/desktop-file-validate ]] ; then
868 einfo "Checking desktop entry validity"
869 local directories=""
870 for d in /usr/share/applications $@ ; do
871 [[ -d ${D}${d} ]] && directories="${directories} ${D}${d}"
872 done
873 if [[ -n ${directories} ]] ; then
874 for FILE in $(find ${directories} -name "*\.desktop" \
875 -not -path '*.hidden*' | sort -u 2>/dev/null)
876 do
877 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
878 sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
879 [[ -n $temp ]] && elog ${temp/--/${FILE/${D}/}:}
880 done
881 fi
882 echo ""
883 else
884 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
885 fi
886 }
887
888 # @FUNCTION: make_session_desktop
889 # @USAGE: <title> <command> [command args...]
890 # @DESCRIPTION:
891 # Make a GDM/KDM Session file. The title is the file to execute to start the
892 # Window Manager. The command is the name of the Window Manager.
893 #
894 # You can set the name of the file via the ${wm} variable.
895 make_session_desktop() {
896 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
897 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
898
899 local title=$1
900 local command=$2
901 local desktop=${T}/${wm:-${PN}}.desktop
902 shift 2
903
904 cat <<-EOF > "${desktop}"
905 [Desktop Entry]
906 Name=${title}
907 Comment=This session logs you into ${title}
908 Exec=${command} $*
909 TryExec=${command}
910 Type=XSession
911 EOF
912
913 (
914 # wrap the env here so that the 'insinto' call
915 # doesn't corrupt the env of the caller
916 insinto /usr/share/xsessions
917 doins "${desktop}"
918 )
919 }
920
921 # @FUNCTION: domenu
922 # @USAGE: <menus>
923 # @DESCRIPTION:
924 # Install the list of .desktop menu files into the appropriate directory
925 # (/usr/share/applications).
926 domenu() {
927 (
928 # wrap the env here so that the 'insinto' call
929 # doesn't corrupt the env of the caller
930 local i j ret=0
931 insinto /usr/share/applications
932 for i in "$@" ; do
933 if [[ -f ${i} ]] ; then
934 doins "${i}"
935 ((ret+=$?))
936 elif [[ -d ${i} ]] ; then
937 for j in "${i}"/*.desktop ; do
938 doins "${j}"
939 ((ret+=$?))
940 done
941 else
942 ((++ret))
943 fi
944 done
945 exit ${ret}
946 )
947 }
948
949 # @FUNCTION: newmenu
950 # @USAGE: <menu> <newname>
951 # @DESCRIPTION:
952 # Like all other new* functions, install the specified menu as newname.
953 newmenu() {
954 (
955 # wrap the env here so that the 'insinto' call
956 # doesn't corrupt the env of the caller
957 insinto /usr/share/applications
958 newins "$@"
959 )
960 }
961
962 # @FUNCTION: _iconins
963 # @INTERNAL
964 # @DESCRIPTION:
965 # function for use in doicon and newicon
966 _iconins() {
967 (
968 # wrap the env here so that the 'insinto' call
969 # doesn't corrupt the env of the caller
970 local funcname=$1; shift
971 local size dir
972 local context=apps
973 local theme=hicolor
974
975 while [[ $# -gt 0 ]] ; do
976 case $1 in
977 -s|--size)
978 if [[ ${2%%x*}x${2%%x*} == "$2" ]] ; then
979 size=${2%%x*}
980 else
981 size=${2}
982 fi
983 case ${size} in
984 16|22|24|32|36|48|64|72|96|128|192|256)
985 size=${size}x${size};;
986 scalable)
987 ;;
988 *)
989 eerror "${size} is an unsupported icon size!"
990 exit 1;;
991 esac
992 shift 2;;
993 -t|--theme)
994 theme=${2}
995 shift 2;;
996 -c|--context)
997 context=${2}
998 shift 2;;
999 *)
1000 if [[ -z ${size} ]] ; then
1001 insinto /usr/share/pixmaps
1002 else
1003 insinto /usr/share/icons/${theme}/${size}/${context}
1004 fi
1005
1006 if [[ ${funcname} == doicon ]] ; then
1007 if [[ -f $1 ]] ; then
1008 doins "${1}"
1009 elif [[ -d $1 ]] ; then
1010 shopt -s nullglob
1011 doins "${1}"/*.{png,svg}
1012 shopt -u nullglob
1013 else
1014 eerror "${1} is not a valid file/directory!"
1015 exit 1
1016 fi
1017 else
1018 break
1019 fi
1020 shift 1;;
1021 esac
1022 done
1023 if [[ ${funcname} == newicon ]] ; then
1024 newins "$@"
1025 fi
1026 ) || die
1027 }
1028
1029 # @FUNCTION: doicon
1030 # @USAGE: [options] <icons>
1031 # @DESCRIPTION:
1032 # Install icon into the icon directory /usr/share/icons or into
1033 # /usr/share/pixmaps if "--size" is not set.
1034 # This is useful in conjunction with creating desktop/menu files.
1035 #
1036 # @CODE
1037 # options:
1038 # -s, --size
1039 # !!! must specify to install into /usr/share/icons/... !!!
1040 # size of the icon, like 48 or 48x48
1041 # supported icon sizes are:
1042 # 16 22 24 32 36 48 64 72 96 128 192 256 scalable
1043 # -c, --context
1044 # defaults to "apps"
1045 # -t, --theme
1046 # defaults to "hicolor"
1047 #
1048 # icons: list of icons
1049 #
1050 # example 1: doicon foobar.png fuqbar.svg suckbar.png
1051 # results in: insinto /usr/share/pixmaps
1052 # doins foobar.png fuqbar.svg suckbar.png
1053 #
1054 # example 2: doicon -s 48 foobar.png fuqbar.png blobbar.png
1055 # results in: insinto /usr/share/icons/hicolor/48x48/apps
1056 # doins foobar.png fuqbar.png blobbar.png
1057 # @CODE
1058 doicon() {
1059 _iconins ${FUNCNAME} "$@"
1060 }
1061
1062 # @FUNCTION: newicon
1063 # @USAGE: [options] <icon> <newname>
1064 # @DESCRIPTION:
1065 # Like doicon, install the specified icon as newname.
1066 #
1067 # @CODE
1068 # example 1: newicon foobar.png NEWNAME.png
1069 # results in: insinto /usr/share/pixmaps
1070 # newins foobar.png NEWNAME.png
1071 #
1072 # example 2: newicon -s 48 foobar.png NEWNAME.png
1073 # results in: insinto /usr/share/icons/hicolor/48x48/apps
1074 # newins foobar.png NEWNAME.png
1075 # @CODE
1076 newicon() {
1077 _iconins ${FUNCNAME} "$@"
1078 }
1079
1080 # @FUNCTION: strip-linguas
1081 # @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
1082 # @DESCRIPTION:
1083 # Make sure that LINGUAS only contains languages that
1084 # a package can support. The first form allows you to
1085 # specify a list of LINGUAS. The -i builds a list of po
1086 # files found in all the directories and uses the
1087 # intersection of the lists. The -u builds a list of po
1088 # files found in all the directories and uses the union
1089 # of the lists.
1090 strip-linguas() {
1091 local ls newls nols
1092 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1093 local op=$1; shift
1094 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1095 local d f
1096 for d in "$@" ; do
1097 if [[ ${op} == "-u" ]] ; then
1098 newls=${ls}
1099 else
1100 newls=""
1101 fi
1102 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1103 if [[ ${op} == "-i" ]] ; then
1104 has ${f} ${ls} && newls="${newls} ${f}"
1105 else
1106 has ${f} ${ls} || newls="${newls} ${f}"
1107 fi
1108 done
1109 ls=${newls}
1110 done
1111 else
1112 ls="$@"
1113 fi
1114
1115 nols=""
1116 newls=""
1117 for f in ${LINGUAS} ; do
1118 if has ${f} ${ls} ; then
1119 newls="${newls} ${f}"
1120 else
1121 nols="${nols} ${f}"
1122 fi
1123 done
1124 [[ -n ${nols} ]] \
1125 && einfo "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1126 export LINGUAS=${newls:1}
1127 }
1128
1129 # @FUNCTION: preserve_old_lib
1130 # @USAGE: <libs to preserve> [more libs]
1131 # @DESCRIPTION:
1132 # These functions are useful when a lib in your package changes ABI SONAME.
1133 # An example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
1134 # would break packages that link against it. Most people get around this
1135 # by using the portage SLOT mechanism, but that is not always a relevant
1136 # solution, so instead you can call this from pkg_preinst. See also the
1137 # preserve_old_lib_notify function.
1138 preserve_old_lib() {
1139 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
1140 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1141 die "Invalid preserve_old_lib() usage"
1142 fi
1143 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1144
1145 # let portage worry about it
1146 has preserve-libs ${FEATURES} && return 0
1147
1148 local lib dir
1149 for lib in "$@" ; do
1150 [[ -e ${ROOT}/${lib} ]] || continue
1151 dir=${lib%/*}
1152 dodir ${dir} || die "dodir ${dir} failed"
1153 cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed"
1154 touch "${D}"/${lib}
1155 done
1156 }
1157
1158 # @FUNCTION: preserve_old_lib_notify
1159 # @USAGE: <libs to notify> [more libs]
1160 # @DESCRIPTION:
1161 # Spit helpful messages about the libraries preserved by preserve_old_lib.
1162 preserve_old_lib_notify() {
1163 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1164 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1165 die "Invalid preserve_old_lib_notify() usage"
1166 fi
1167
1168 # let portage worry about it
1169 has preserve-libs ${FEATURES} && return 0
1170
1171 local lib notice=0
1172 for lib in "$@" ; do
1173 [[ -e ${ROOT}/${lib} ]] || continue
1174 if [[ ${notice} -eq 0 ]] ; then
1175 notice=1
1176 ewarn "Old versions of installed libraries were detected on your system."
1177 ewarn "In order to avoid breaking packages that depend on these old libs,"
1178 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1179 ewarn "in order to remove these old dependencies. If you do not have this"
1180 ewarn "helper program, simply emerge the 'gentoolkit' package."
1181 ewarn
1182 fi
1183 ewarn " # revdep-rebuild --library '${lib}' && rm '${lib}'"
1184 done
1185 }
1186
1187 # @FUNCTION: built_with_use
1188 # @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1189 # @DESCRIPTION:
1190 #
1191 # Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1192 #
1193 # A temporary hack until portage properly supports DEPENDing on USE
1194 # flags being enabled in packages. This will check to see if the specified
1195 # DEPEND atom was built with the specified list of USE flags. The
1196 # --missing option controls the behavior if called on a package that does
1197 # not actually support the defined USE flags (aka listed in IUSE).
1198 # The default is to abort (call die). The -a and -o flags control
1199 # the requirements of the USE flags. They correspond to "and" and "or"
1200 # logic. So the -a flag means all listed USE flags must be enabled
1201 # while the -o flag means at least one of the listed IUSE flags must be
1202 # enabled. The --hidden option is really for internal use only as it
1203 # means the USE flag we're checking is hidden expanded, so it won't be found
1204 # in IUSE like normal USE flags.
1205 #
1206 # Remember that this function isn't terribly intelligent so order of optional
1207 # flags matter.
1208 built_with_use() {
1209 local hidden="no"
1210 if [[ $1 == "--hidden" ]] ; then
1211 hidden="yes"
1212 shift
1213 fi
1214
1215 local missing_action="die"
1216 if [[ $1 == "--missing" ]] ; then
1217 missing_action=$2
1218 shift ; shift
1219 case ${missing_action} in
1220 true|false|die) ;;
1221 *) die "unknown action '${missing_action}'";;
1222 esac
1223 fi
1224
1225 local opt=$1
1226 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
1227
1228 local PKG=$(best_version $1)
1229 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package"
1230 shift
1231
1232 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE
1233 local IUSEFILE=${ROOT}/var/db/pkg/${PKG}/IUSE
1234
1235 # if the IUSE file doesn't exist, the read will error out, we need to handle
1236 # this gracefully
1237 if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then
1238 case ${missing_action} in
1239 true) return 0;;
1240 false) return 1;;
1241 die) die "Unable to determine what USE flags $PKG was built with";;
1242 esac
1243 fi
1244
1245 if [[ ${hidden} == "no" ]] ; then
1246 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1247 # Don't check USE_EXPAND #147237
1248 local expand
1249 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1250 if [[ $1 == ${expand}_* ]] ; then
1251 expand=""
1252 break
1253 fi
1254 done
1255 if [[ -n ${expand} ]] ; then
1256 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1257 case ${missing_action} in
1258 true) return 0;;
1259 false) return 1;;
1260 die) die "$PKG does not actually support the $1 USE flag!";;
1261 esac
1262 fi
1263 fi
1264 fi
1265
1266 local USE_BUILT=$(<${USEFILE})
1267 while [[ $# -gt 0 ]] ; do
1268 if [[ ${opt} = "-o" ]] ; then
1269 has $1 ${USE_BUILT} && return 0
1270 else
1271 has $1 ${USE_BUILT} || return 1
1272 fi
1273 shift
1274 done
1275 [[ ${opt} = "-a" ]]
1276 }
1277
1278 # @FUNCTION: epunt_cxx
1279 # @USAGE: [dir to scan]
1280 # @DESCRIPTION:
1281 # Many configure scripts wrongly bail when a C++ compiler could not be
1282 # detected. If dir is not specified, then it defaults to ${S}.
1283 #
1284 # http://bugs.gentoo.org/73450
1285 epunt_cxx() {
1286 local dir=$1
1287 [[ -z ${dir} ]] && dir=${S}
1288 ebegin "Removing useless C++ checks"
1289 local f p any_found
1290 while IFS= read -r -d '' f; do
1291 for p in "${PORTDIR}"/eclass/ELT-patches/nocxx/*.patch ; do
1292 if patch --no-backup-if-mismatch -p1 "${f}" "${p}" >/dev/null ; then
1293 any_found=1
1294 break
1295 fi
1296 done
1297 done < <(find "${dir}" -name configure -print0)
1298
1299 if [[ -z ${any_found} ]]; then
1300 eqawarn "epunt_cxx called unnecessarily (no C++ checks to punt)."
1301 fi
1302 eend 0
1303 }
1304
1305 # @FUNCTION: make_wrapper
1306 # @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1307 # @DESCRIPTION:
1308 # Create a shell wrapper script named wrapper in installpath
1309 # (defaults to the bindir) to execute target (default of wrapper) by
1310 # first optionally setting LD_LIBRARY_PATH to the colon-delimited
1311 # libpaths followed by optionally changing directory to chdir.
1312 make_wrapper() {
1313 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1314 local tmpwrapper=$(emktemp)
1315
1316 (
1317 echo '#!/bin/sh'
1318 [[ -n ${chdir} ]] && printf 'cd "%s"\n' "${chdir}"
1319 if [[ -n ${libdir} ]] ; then
1320 cat <<-EOF
1321 if [ "\${LD_LIBRARY_PATH+set}" = "set" ] ; then
1322 export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}"
1323 else
1324 export LD_LIBRARY_PATH="${libdir}"
1325 fi
1326 EOF
1327 fi
1328 # We don't want to quote ${bin} so that people can pass complex
1329 # things as ${bin} ... "./someprog --args"
1330 printf 'exec %s "$@"\n' "${bin}"
1331 ) > "${tmpwrapper}"
1332 chmod go+rx "${tmpwrapper}"
1333
1334 if [[ -n ${path} ]] ; then
1335 (
1336 exeinto "${path}"
1337 newexe "${tmpwrapper}" "${wrapper}"
1338 ) || die
1339 else
1340 newbin "${tmpwrapper}" "${wrapper}" || die
1341 fi
1342 }
1343
1344 # @FUNCTION: path_exists
1345 # @USAGE: [-a|-o] <paths>
1346 # @DESCRIPTION:
1347 # Check if the specified paths exist. Works for all types of paths
1348 # (files/dirs/etc...). The -a and -o flags control the requirements
1349 # of the paths. They correspond to "and" and "or" logic. So the -a
1350 # flag means all the paths must exist while the -o flag means at least
1351 # one of the paths must exist. The default behavior is "and". If no
1352 # paths are specified, then the return value is "false".
1353 path_exists() {
1354 local opt=$1
1355 [[ ${opt} == -[ao] ]] && shift || opt="-a"
1356
1357 # no paths -> return false
1358 # same behavior as: [[ -e "" ]]
1359 [[ $# -eq 0 ]] && return 1
1360
1361 local p r=0
1362 for p in "$@" ; do
1363 [[ -e ${p} ]]
1364 : $(( r += $? ))
1365 done
1366
1367 case ${opt} in
1368 -a) return $(( r != 0 )) ;;
1369 -o) return $(( r == $# )) ;;
1370 esac
1371 }
1372
1373 # @FUNCTION: in_iuse
1374 # @USAGE: <flag>
1375 # @DESCRIPTION:
1376 # Determines whether the given flag is in IUSE. Strips IUSE default prefixes
1377 # as necessary.
1378 #
1379 # Note that this function should not be used in the global scope.
1380 in_iuse() {
1381 debug-print-function ${FUNCNAME} "${@}"
1382 [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
1383
1384 local flag=${1}
1385 local liuse=( ${IUSE} )
1386
1387 has "${flag}" "${liuse[@]#[+-]}"
1388 }
1389
1390 # @FUNCTION: use_if_iuse
1391 # @USAGE: <flag>
1392 # @DESCRIPTION:
1393 # Return true if the given flag is in USE and IUSE.
1394 #
1395 # Note that this function should not be used in the global scope.
1396 use_if_iuse() {
1397 in_iuse $1 || return 1
1398 use $1
1399 }
1400
1401 # @FUNCTION: usex
1402 # @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
1403 # @DESCRIPTION:
1404 # Proxy to declare usex for package managers or EAPIs that do not provide it
1405 # and use the package manager implementation when available (i.e. EAPI >= 5).
1406 # If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
1407 # otherwise echo [false output][false suffix] (defaults to "no").
1408 if has "${EAPI:-0}" 0 1 2 3 4; then
1409 usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963
1410 fi
1411
1412 # @FUNCTION: prune_libtool_files
1413 # @USAGE: [--all|--modules]
1414 # @DESCRIPTION:
1415 # Locate unnecessary libtool files (.la) and libtool static archives
1416 # (.a) and remove them from installation image.
1417 #
1418 # By default, .la files are removed whenever the static linkage can
1419 # either be performed using pkg-config or doesn't introduce additional
1420 # flags.
1421 #
1422 # If '--modules' argument is passed, .la files for modules (plugins) are
1423 # removed as well. This is usually useful when the package installs
1424 # plugins and the plugin loader does not use .la files.
1425 #
1426 # If '--all' argument is passed, all .la files are removed without
1427 # performing any heuristic on them. You shouldn't ever use that,
1428 # and instead report a bug in the algorithm instead.
1429 #
1430 # The .a files are only removed whenever corresponding .la files state
1431 # that they should not be linked to, i.e. whenever these files
1432 # correspond to plugins.
1433 #
1434 # Note: if your package installs both static libraries and .pc files
1435 # which use variable substitution for -l flags, you need to add
1436 # pkg-config to your DEPEND.
1437 prune_libtool_files() {
1438 debug-print-function ${FUNCNAME} "$@"
1439
1440 local removing_all removing_modules opt
1441 for opt; do
1442 case "${opt}" in
1443 --all)
1444 removing_all=1
1445 removing_modules=1
1446 ;;
1447 --modules)
1448 removing_modules=1
1449 ;;
1450 *)
1451 die "Invalid argument to ${FUNCNAME}(): ${opt}"
1452 esac
1453 done
1454
1455 local f
1456 local queue=()
1457 while IFS= read -r -d '' f; do # for all .la files
1458 local archivefile=${f/%.la/.a}
1459
1460 [[ ${f} != ${archivefile} ]] || die 'regex sanity check failed'
1461 local reason pkgconfig_scanned
1462 local snotlink=$(sed -n -e 's:^shouldnotlink=::p' "${f}")
1463
1464 if [[ ${snotlink} == yes ]]; then
1465
1466 # Remove static libs we're not supposed to link against.
1467 if [[ -f ${archivefile} ]]; then
1468 einfo "Removing unnecessary ${archivefile#${D%/}} (static plugin)"
1469 queue+=( "${archivefile}" )
1470 fi
1471
1472 # The .la file may be used by a module loader, so avoid removing it
1473 # unless explicitly requested.
1474 if [[ ${removing_modules} ]]; then
1475 reason='module'
1476 fi
1477
1478 elif [[ ${snotlink} == no ]]; then
1479
1480 # A valid .la file must have a valid 'shouldnotlink='.
1481 # That assumption helps us avoid removing random files
1482 # which match '*.la', see bug #468380.
1483
1484 # Remove .la files when:
1485 # - user explicitly wants us to remove all .la files,
1486 # - respective static archive doesn't exist,
1487 # - they are covered by a .pc file already,
1488 # - they don't provide any new information (no libs & no flags).
1489
1490 if [[ ${removing_all} ]]; then
1491 reason='requested'
1492 elif [[ ! -f ${archivefile} ]]; then
1493 reason='no static archive'
1494 elif [[ ! $(sed -nre \
1495 "s/^(dependency_libs|inherited_linker_flags)='(.*)'$/\2/p" \
1496 "${f}") ]]; then
1497 reason='no libs & flags'
1498 else
1499 if [[ ! ${pkgconfig_scanned} ]]; then
1500 # Create a list of all .pc-covered libs.
1501 local pc_libs=()
1502 if [[ ! ${removing_all} ]]; then
1503 local pc
1504 local tf=${T}/prune-lt-files.pc
1505 local pkgconf=$(tc-getPKG_CONFIG)
1506
1507 while IFS= read -r -d '' pc; do # for all .pc files
1508 local arg libs
1509
1510 # Use pkg-config if available (and works),
1511 # fallback to sed.
1512 if ${pkgconf} --exists "${pc}" &>/dev/null; then
1513 sed -e '/^Requires:/d' "${pc}" > "${tf}"
1514 libs=$(${pkgconf} --libs "${tf}")
1515 else
1516 libs=$(sed -ne 's/^Libs://p' "${pc}")
1517 fi
1518
1519 for arg in ${libs}; do
1520 if [[ ${arg} == -l* ]]; then
1521 if [[ ${arg} == '*$*' ]]; then
1522 eqawarn "${FUNCNAME}: variable substitution likely failed in ${pc}"
1523 eqawarn "(arg: ${arg})"
1524 eqawarn "Most likely, you need to add virtual/pkgconfig to DEPEND."
1525 fi
1526
1527 pc_libs+=( lib${arg#-l}.la )
1528 fi
1529 done
1530 done < <(find "${D}" -type f -name '*.pc' -print0)
1531
1532 rm -f "${tf}"
1533 fi
1534
1535 pkgconfig_scanned=1
1536 fi # pkgconfig_scanned
1537
1538 has "${f##*/}" "${pc_libs[@]}" && reason='covered by .pc'
1539 fi # removal due to .pc
1540
1541 fi # shouldnotlink==no
1542
1543 if [[ ${reason} ]]; then
1544 einfo "Removing unnecessary ${f#${D%/}} (${reason})"
1545 queue+=( "${f}" )
1546 fi
1547 done < <(find "${D}" -xtype f -name '*.la' -print0)
1548
1549 if [[ ${queue[@]} ]]; then
1550 rm -f "${queue[@]}"
1551 fi
1552 }
1553
1554 check_license() { die "you no longer need this as portage supports ACCEPT_LICENSE itself"; }
1555
1556 fi

  ViewVC Help
Powered by ViewVC 1.1.20